clear all; clf; clc; % vide toute la mémoire, vire tout ce qui était affiché
son = load('violon.txt');
Fe = 44100; % paramètre qui nous est donné : la fréquence d'échantionnage
Te = 1 / Fe; % la période d'échantionnage
N = length(son); % Nombre de points dans le signal

freq = [0:N-1]'/(N*Te); % espace des fréquences
TF_son = fft(son); % Transformée de fourier

plot(freq, abs(TF_son)); %Tracé du spectre
% Annotation des axes
xlabel('Frequence (Hz)');
ylabel('Spectre')

TF_half = TF_son([1:N/2]); % on ne garde que la moitié
freq_half = freq([1:N/2]);

seuil = max(abs(TF_half)) / 100; % valeur du seuil choisie à 1/500 de la composante d'amplitude maximale 

a_garder = abs(TF_half) > seuil; %à garder, oui ou non? 
indices = [1:N/2]';

indices_non_nuls = indices(a_garder);
valeurs_non_nulles = TF_half(a_garder);

tosave = [indices_non_nuls real(valeurs_non_nulles) imag(valeurs_non_nulles)];
tosave = single(tosave);
save('son_compresse.txt','tosave','-ascii')




